.686p
.model  flat, stdcall
option  casemap :none   ; case sensitive
.xmm
.nolist
include windows.inc
inv equ Invoke

MaxTests    equ 99          ; maximum number of timing tests, increase as desired up to 999
PriClass textequ <REALTIME_PRIORITY_CLASS> ; priority to use for tests
;PriClass textequ <NORMAL_PRIORITY_CLASS>   ; for debugging


soff Macro QuotedText:Vararg    ; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm

Desc Macro TextVal:Req  ; used in the first line of each test proc (Doit1....Doitxx)
local DescLoc, FirstFlag

.data
FirstFlag dd 0
DescLoc db TextVal,0
.code
    .if FirstFlag==0    ; if not first time, just continue
        mov FirstFlag,1 ; set done for next time
        mov ebx,offset DescLoc
        call SetDesc
        ret     ; if this was the first time, just return without running rest of code
    .endif
endm

.data?
align 16
hWin          dd ?  ; dialog handle
hEdit         dd ?
StartingCycle dd ?
CyclePart2    dd ?
Loops         dd ?
ExtraLoops    dd ?
Min           dd ?
OverHead      dd ?   ; overhead of doing an empty proc
Result        dd ?
.data
 DoingOverhead dd 0
.code

BeginCounter macro  ; This macro is inserted before a block of test code
    align 16    ; just to be sure all code starts with equal advantage
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, PriClass  ; use the highest priority for all the tests
    invoke GetCurrentThread
    inv SetThreadPriority,eax,THREAD_PRIORITY_TIME_CRITICAL
            
    mov Min,9999999999
    mov Loops,TimesToLoop
    mov ExtraLoops,10   ; will do several times first to let things settle out
    inv Sleep,0
ExtraLoopsLoop = $
    sub ExtraLoops,1
TimingLoop = $
    mov [StartingCycle],eax     ; just to make sure they are in the cache
    mov [StartingCycle+4],eax
    Repeat 6    ; Intel says 4 but I've found that more works a little better
    xor eax,eax
    cpuid       ; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
    Endm
    rdtsc
    mov [StartingCycle],eax
    mov [StartingCycle+4],edx
endm
EndCounter macro        ; This macro is inserted after each block of test code
    xor eax,eax
    cpuid       ; flush
    rdtsc
    cmp ExtraLoops,0
    jne ExtraLoopsLoop  ; skip first several iterations
    sub eax,[StartingCycle] ; get result in EDX:EAX
    sbb edx,[StartingCycle+4]
    cmp Min,eax
    jb @f
    mov Min,eax
@@:
    sub Loops,1
    jnz TimingLoop
    invoke GetCurrentThread
    inv SetThreadPriority,eax,THREAD_PRIORITY_NORMAL
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, NORMAL_PRIORITY_CLASS ; back to normal
    inv Sleep,0 
    mov eax,Min     ; return the minimum elapsed time
    .if DoingOverhead==0
        sub eax,OverHead
    .endif
    ;call Wrapup2
    mov Result,eax
    invoke wsprintf,addr buff,soff("%i"),Result
    mov eax,TestNum
    add eax,5000        ; Result cycles
    GetHandle eax,hEdit
    invoke SendMessage,hEdit,WM_SETTEXT,0,addr buff
endm


msg Macro qtext:VARARG
local result
pusha
    quote SUBSTR <qtext>,1,1
    IFIDN quote , <">  ;; if this is a quoted string
        invoke MessageBox,0,soff(qtext),0,0
    else
        result=opattr(qtext)
        if result eq 48 ;; a register
            invoke MessageBox,0,qtext,0,0
        else
            invoke MessageBox,0,addr qtext,0,0
        endif
    endif   
popa
endm

prtd MACRO argf	; debugging print
pusha
mov edx,argf
inv dwtoa,edx,addr dwtoabuf
invoke MessageBox,0,addr dwtoabuf,0,0
popa
EndM

GetHandle Macro MyId:Req,MyHandle:Req 
    invoke GetDlgItem,hWin,MyId
    mov MyHandle,eax         ; save handle to control
endm

uselib  MACRO   libname
    include     libname.inc
    includelib  libname.lib
ENDM

uselib user32
uselib kernel32
uselib comctl32
uselib gdi32

;uselib shell32
;uselib comdlg32
uselib masm32
uselib debug
.listall

DlgProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD

;scratch for tests
.data?
align 4
temp1   dd ?    ; aligned
temp2   dd ?
buff db 100 dup (?)
dwtoabuf db 12 dup (?)
align 8
count2 dq ?
.code
start:
    invoke  InitCommonControls
    invoke  GetModuleHandle, NULL
    invoke  DialogBoxParam, eax, 101, 0, ADDR DlgProc, 0
    invoke  ExitProcess, eax


