TimesToLoop equ 100;00;00;0 ; number of times to loop
include Part1.inc
; -------------------------------------  Timing Tests -----------------------------------

; This is the code to copy to create new timing tests. Copy this code and paste it below.
; Change the X in DoitX to a number (Doit1, Doit2,...Doit99)
DoitX:
    Desc ' ' ;insert description of this test between single quotes
    ; -- place any setup desired here.  Registers will not be preserved into test code --
    BeginCounter    ; place test code here between BeginCounter and EndCounter ----------

    EndCounter      ; end of test code --------------------------------------------------
    ret

;--------------------------------- Test Procs -------------------------------------------

;  Place any test procs or setup/checking procs you wish here

;---------------------------- Routines Being Timed --------------------------------------  

.data
dtst db 256 dup (0)
	 dd 0	; guard bytes
tans dd 0
dans dd 256*255
.code
setup proc
	mov edi,offset dtst
	mov ecx,256
	mov edx,0
	mov eax,0
	.repeat
		add edx,eax
		stosb
		inc eax
		dec ecx
	.until ecx==0
	mov dans,edx
	ret
setup EndP
Doit1:       ;---------------------------------------------------------------------------
	Desc 'movzx, add'
	call setup
	BeginCounter
		mov esi,offset dtst
		xor eax, eax
		mov ecx, 256
		counter_loop:
		movzx ebx, BYTE PTR [esi]
		add eax, ebx
		inc esi
		loop counter_loop
		mov tans,eax
	EndCounter
	mov eax,tans
	.if eax!=dans
		msg "error"
	.endif
	ret

Doit2:       ;---------------------------------------------------------------------------
	Desc 'movzx, add, no LOOP'
	call setup
	BeginCounter
		mov esi,offset dtst
		xor eax, eax
		mov ecx, 256
		.repeat
			movzx ebx, BYTE PTR [esi]
			add eax, ebx
			inc esi
			dec ecx
		.until ecx==0
		mov tans,eax
	EndCounter
	mov eax,tans
	.if eax!=dans
		msg "error"
	.endif
	ret

Doit3:       ;---------------------------------------------------------------------------
	Desc '2 byte add'
	call setup
	BeginCounter
		mov esi,offset dtst+255-3
		xor eax, eax
		.repeat
			mov edx,[esi]
			and edx,0FF00FFh
			add eax,edx
			sub esi,4
		.until esi<offset dtst

		mov esi,offset dtst+255-2
		.repeat
			mov edx,[esi]
			and edx,0FF00FFh
			add eax,edx
			sub esi,4
		.until esi<offset dtst
		mov edx,eax
		shr eax,16
		and edx,0FFFFh
		add eax,edx
		mov tans,eax
	EndCounter
	mov eax,tans
	.if eax!=dans
		msg "error"
	.endif
	ret

.data
mmxmask db 255,00,255,00,255,0,255,0
qans dq 0
.code
Doit4:       ;---------------------------------------------------------------------------
	Desc 'mmx'
	call setup
	BeginCounter
		emms
		mov esi,offset dtst+256-8
		pxor mm0,mm0
		mov edi,offset mmxmask
		movq mm2,[edi]
		.repeat
			movq mm1,[esi]
			pand mm1,mm2
			paddw mm0,mm1
			sub esi,8
		.until esi<offset dtst

		mov esi,offset dtst+256-7
		.repeat
			movq mm1,[esi]
			pand mm1,mm2
			paddw mm0,mm1
			sub esi,8
		.until esi<offset dtst
		movq qans,mm0
		movq mm1,qans
		movzx eax,word ptr qans
		movzx edx,word ptr [qans+2]
		add eax,edx
		movzx edx,word ptr [qans+4]
		add eax,edx
		movzx edx,word ptr [qans+6]
		add eax,edx
		mov tans,eax
		
	EndCounter
	mov eax,tans
	.if eax!=dans
		msg "error"
	.endif
	ret

align 16
SumBytes proc stdcall _pByteArray:ptr byte,_dwCount:dword
option prologue:none
option epilogue:none
pByteArray equ <dword ptr [esp+1*4][4]>
dwCount     equ <dword ptr [esp+2*4][4]>
push ebx
mov ecx,dwCount
xor eax,eax
mov edx,ecx
shr ecx,3
mov ebx,pByteArray
jz @F
pxor mm2,mm2
pxor mm3,mm3
.repeat
movq mm0,[ebx]
add ebx,8
movq mm1,mm0
punpcklbw mm0,mm2
punpckhbw mm1,mm2
paddw mm3,mm0
paddw mm3,mm1
sub ecx,1
.until zero?
movq mm0,mm3
punpcklwd mm0,mm2
punpckhwd mm3,mm2
paddd mm0,mm3
movd ecx,mm0
add eax,ecx
psrlq mm0,32
movd ecx,mm0
add eax,ecx
@@: and edx,7
jz @F
.repeat
movzx ecx,byte ptr[ebx]
add eax,ecx
add ebx,1
sub edx,1
.until zero?
@@: pop ebx
ret 2*4
option prologue:prologuedef
option epilogue:epiloguedef
SumBytes endp

Doit5:
    Desc 'driz'
	call setup
    BeginCounter
	invoke SumBytes,addr dtst,256
	mov tans,eax
    EndCounter
	mov eax,tans
	 .if eax != dans
		msg " error"
	.endif
    ret

Doit6:       ;---------------------------------------------------------------------------
	Desc 'mmx 1loop'
	call setup
	BeginCounter
		emms
		mov esi,offset dtst+256-8
		pxor mm0,mm0
		mov edi,offset mmxmask
		movq mm2,[edi]
		.repeat
			movq mm1,[esi]
			pand mm1,mm2
			paddw mm0,mm1
			movq mm3,[esi+1]
			pand mm3,mm2
			paddw mm0,mm3
			sub esi,8
		.until esi<offset dtst

		movq qans,mm0
		movq mm1,qans
		movzx eax,word ptr qans
		movzx edx,word ptr [qans+2]
		add eax,edx
		movzx edx,word ptr [qans+4]
		add eax,edx
		movzx edx,word ptr [qans+6]
		add eax,edx
		mov tans,eax
		
	EndCounter
	mov eax,tans
	.if eax!=dans
		msg "error"
	.endif
	ret


Doit7:       ;---------------------------------------------------------------------------
	Desc 'mmx 2 interleaved'
	call setup
	BeginCounter
		emms
		mov esi,offset dtst+256-16
		pxor mm0,mm0
		mov edi,offset mmxmask
		movq mm2,[edi]
		.repeat
			movq mm1,[esi]
			movq mm3,[esi+1]
			movq mm4,[esi+8]
			movq mm5,[esi+9]
			pand mm1,mm2
			pand mm3,mm2
			pand mm4,mm2
			pand mm5,mm2
			paddw mm0,mm1
			paddw mm4,mm5
			paddw mm0,mm3
			paddw mm0,mm4
			sub esi,16
		.until esi<offset dtst

		movq qans,mm0
		movq mm1,qans
		movzx eax,word ptr qans
		movzx edx,word ptr [qans+2]
		add eax,edx
		movzx edx,word ptr [qans+4]
		add eax,edx
		movzx edx,word ptr [qans+6]
		add eax,edx
		mov tans,eax
		
	EndCounter
	mov eax,tans
	.if eax!=dans
		msg "error"
	.endif
	ret

;               ------------------------ end of timing tests --------------------
include Part2.inc